package com.bleujin.framework.db;

import com.bleujin.framework.db.manager.DBManager;
import com.bleujin.framework.db.procedure.Queryable;
import com.bleujin.framework.db.procedure.UserProcedures;
import com.bleujin.framework.db.servant.AfterTask;
import com.bleujin.framework.db.servant.ExtraServant;
import com.bleujin.framework.db.servant.NoneServant;

public class BatchDBController extends DBController { // implements Configurable

    private ExtraServant servant = null ;

    public BatchDBController(String name, DBManager dbm) {
        this(name, dbm, new NoneServant());
    }

    public BatchDBController(String name, DBManager dataBaseManager, ExtraServant servant) {
        super(name, dataBaseManager) ;
        this.servant = servant ;
    }

    protected void handleServant(long start, long end, UserProcedures query, int execType) {
        servant.support(new AfterTask(start, end, this.getDBManager(), query, execType));
    }

    protected void handleServant(long start, long end, Queryable query, int execType) {
        servant.support(new AfterTask(start, end, this.getDBManager(), query, execType));
    }

}
