package com.bleujin.framework.db;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.sql.SQLException;
import java.util.Arrays;

import com.bleujin.framework.util.Debug;

public class InvokeRows implements InvocationHandler{
	
	private Rows real;
	private RuntimeException switchException;

	public InvokeRows(Rows real) {
		this(real, new RuntimeException()) ;
	}

	public InvokeRows(Rows real, RuntimeException switchException) {
		this.real = real;
		this.switchException = switchException;
	}
	
	public Row firstRow() {
		return real.firstRow();
	}
	
	
	private RuntimeException switchException(Exception ex) throws Exception{
		if (ex.getClass() != SQLException.class) throw ex ;
		
		Class[] args = new Class[] {String.class, Throwable.class };
		Object o = null;
		try {
			Constructor con = switchException.getClass().getConstructor(args);
			o = con.newInstance(ex.getMessage(), ex);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return (RuntimeException)o ;

	}
	
	public Object invoke(Object proxy, Method m, Object[] args) throws Throwable {
		try {
			Debug.debug(m.getName() + "(" + Arrays.toString(args) + ")");
			return m.invoke(real, args);
		} catch (Exception e) {
			throw switchException(e) ;
		}
	}
}
