package com.bleujin.framework.db;

import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;
import java.io.Writer;
import java.lang.reflect.Constructor;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.Array;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.Date;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Statement;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Collection;
import java.util.Map;

import javax.sql.RowSetListener;
import javax.sql.RowSetMetaData;

import com.bleujin.framework.db.bean.ResultSetHandler;

public class NRows implements Rows {

	private Rows real;
	private RuntimeException switchException;

	public NRows(Rows real) {
		this(real, new RuntimeException()) ;
	}

	public NRows(Rows real, RuntimeException switchException) {
		this.real = real;
		this.switchException = switchException;
	}

	public Row firstRow() {
		return real.firstRow();
	}
	
	private RuntimeException switchException(Exception ex){
		Class[] args = new Class[] {String.class, Throwable.class };
		Object o = null;
		try {
			Constructor con = switchException.getClass().getConstructor(args);
			o = con.newInstance(ex.getMessage(), ex);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return (RuntimeException)o ;

	}

	public String getDefaultString(String col1, String defaultString) {
		try {
			return real.getDefaultString(col1, defaultString);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public IXmlWriter getIXmlWriter() {
		try {
			return real.getIXmlWriter();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Rows getNextRows() {
		return real.getNextRows();
	}

	public int getRowCount() {
		return real.getRowCount();
	}

	public boolean getShowDeleted() {
		try {
			return real.getShowDeleted();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public String getTableName() {
		try {
			return real.getTableName();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void populate(ResultSet rs) {
		try {
			real.populate(rs);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void populate(ResultSet rs, int skip, int length) {
		try {
			real.populate(rs, skip, length);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Rows setNextRows(Rows rows) {
		return real.setNextRows(rows);
	}

	public void setTableName(String name) {
		try {
			real.setTableName(name);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setXmlWriter(IXmlWriter writer) {
		try {
			real.setXmlWriter(writer);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Collection toCollection() {
		try {
			return real.toCollection();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void writeXml(Writer writer, IXmlWriter xmlWriter) {
		try {
			real.writeXml(writer, xmlWriter);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void writeXml(Writer writer) {
		try {
			real.writeXml(writer);
		} catch (SQLException e) {
			throw switchException(e) ;
		} catch (IOException e) {
			throw switchException(e) ;
		}
	}

	public void addRowSetListener(RowSetListener arg0) {
		real.addRowSetListener(arg0);
	}

	public void clearParameters() {
		try {
			real.clearParameters();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void execute() {
		try {
			real.execute();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public String getCommand() {
		return real.getCommand();
	}

	public String getDataSourceName() {
		return real.getDataSourceName();
	}

	public boolean getEscapeProcessing() {
		try {
			return real.getEscapeProcessing();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getMaxFieldSize() {
		try {
			return real.getMaxFieldSize();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getMaxRows() {
		try {
			return real.getMaxRows();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public String getPassword() {
		return real.getPassword();
	}

	public int getQueryTimeout() {
		try {
			return real.getQueryTimeout();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getTransactionIsolation() {
		return real.getTransactionIsolation();
	}

	public Map getTypeMap() {
		try {
			return real.getTypeMap();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public String getUrl() {
		try {
			return real.getUrl();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public String getUsername() {
		return real.getUsername();
	}

	public boolean isReadOnly() {
		return real.isReadOnly();
	}

	public void removeRowSetListener(RowSetListener arg0) {
		real.removeRowSetListener(arg0);
	}

	public void setArray(int arg0, Array arg1) {
		try {
			real.setArray(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setAsciiStream(int arg0, InputStream arg1, int arg2) {
		try {
			real.setAsciiStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setBigDecimal(int arg0, BigDecimal arg1) {
		try {
			real.setBigDecimal(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setBinaryStream(int arg0, InputStream arg1, int arg2) {
		try {
			real.setBinaryStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setBlob(int arg0, Blob arg1) {
		try {
			real.setBlob(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setBoolean(int arg0, boolean arg1) {
		try {
			real.setBoolean(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setByte(int arg0, byte arg1) {
		try {
			real.setByte(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setBytes(int arg0, byte[] arg1) {
		try {
			real.setBytes(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setCharacterStream(int arg0, Reader arg1, int arg2) {
		try {
			real.setCharacterStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setClob(int arg0, Clob arg1) {
		try {
			real.setClob(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setCommand(String arg0) {
		try {
			real.setCommand(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setConcurrency(int arg0) {
		try {
			real.setConcurrency(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setDataSourceName(String arg0) {
		try {
			real.setDataSourceName(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setDate(int arg0, Date arg1) {
		try {
			real.setDate(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setDate(int arg0, Date arg1, Calendar arg2) {
		try {
			real.setDate(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setDouble(int arg0, double arg1) {
		try {
			real.setDouble(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setEscapeProcessing(boolean arg0) {
		try {
			real.setEscapeProcessing(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setFloat(int arg0, float arg1) {
		try {
			real.setFloat(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setInt(int arg0, int arg1) {
		try {
			real.setInt(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setLong(int arg0, long arg1) {
		try {
			real.setLong(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setMaxFieldSize(int arg0) {
		try {
			real.setMaxFieldSize(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setMaxRows(int arg0) {
		try {
			real.setMaxRows(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setNull(int arg0, int arg1) {
		try {
			real.setNull(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setNull(int arg0, int arg1, String arg2) {
		try {
			real.setNull(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setObject(int arg0, Object arg1) {
		try {
			real.setObject(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setObject(int arg0, Object arg1, int arg2) {
		try {
			real.setObject(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setObject(int arg0, Object arg1, int arg2, int arg3) {
		try {
			real.setObject(arg0, arg1, arg2, arg3);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setPassword(String arg0) {
		try {
			real.setPassword(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setQueryTimeout(int arg0) {
		try {
			real.setQueryTimeout(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setReadOnly(boolean arg0) {
		try {
			real.setReadOnly(arg0);
		} catch (SQLException e) {
			throw (RuntimeException) switchException.initCause(e) ;
		}
	}

	public void setRef(int arg0, Ref arg1) {
		try {
			real.setRef(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setShort(int arg0, short arg1) {
		try {
			real.setShort(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setString(int arg0, String arg1) {
		try {
			real.setString(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setTime(int arg0, Time arg1) {
		try {
			real.setTime(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setTime(int arg0, Time arg1, Calendar arg2) {
		try {
			real.setTime(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setTimestamp(int arg0, Timestamp arg1) {
		try {
			real.setTimestamp(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setTimestamp(int arg0, Timestamp arg1, Calendar arg2) {
		try {
			real.setTimestamp(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setTransactionIsolation(int arg0) {
		try {
			real.setTransactionIsolation(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setType(int arg0) {
		try {
			real.setType(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}


	public void setUrl(String arg0) {
		try {
			real.setUrl(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setUsername(String arg0) {
		try {
			real.setUsername(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean absolute(int arg0) {
		try {
			return real.absolute(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void afterLast() {
		try {
			real.afterLast();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void beforeFirst() {
		try {
			real.beforeFirst();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void cancelRowUpdates() {
		try {
			real.cancelRowUpdates();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void clearWarnings() {
		try {
			real.clearWarnings();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void close() {
		try {
			real.close();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void deleteRow() {
		try {
			real.deleteRow();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int findColumn(String arg0) {
		try {
			return real.findColumn(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean first() {
		try {
			return real.first();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Array getArray(int arg0) {
		try {
			return real.getArray(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Array getArray(String arg0) {
		try {
			return real.getArray(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public InputStream getAsciiStream(int arg0) {
		try {
			return real.getAsciiStream(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public InputStream getAsciiStream(String arg0) {
		try {
			return real.getAsciiStream(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public BigDecimal getBigDecimal(int arg0) {
		try {
			return real.getBigDecimal(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public BigDecimal getBigDecimal(String arg0) {
		try {
			return real.getBigDecimal(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public BigDecimal getBigDecimal(int arg0, int arg1) {
		try {
			return real.getBigDecimal(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public BigDecimal getBigDecimal(String arg0, int arg1) {
		try {
			return real.getBigDecimal(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public InputStream getBinaryStream(int arg0) {
		try {
			return real.getBinaryStream(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public InputStream getBinaryStream(String arg0) {
		try {
			return real.getBinaryStream(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Blob getBlob(int arg0) {
		try {
			return real.getBlob(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Blob getBlob(String arg0) {
		try {
			return real.getBlob(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean getBoolean(int arg0) {
		try {
			return real.getBoolean(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean getBoolean(String arg0) {
		try {
			return real.getBoolean(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public byte getByte(int arg0) {
		try {
			return real.getByte(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public byte getByte(String arg0) {
		try {
			return real.getByte(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public byte[] getBytes(int arg0) {
		try {
			return real.getBytes(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public byte[] getBytes(String arg0) {
		try {
			return real.getBytes(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Reader getCharacterStream(int arg0) {
		try {
			return real.getCharacterStream(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Reader getCharacterStream(String arg0) {
		try {
			return real.getCharacterStream(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Clob getClob(int arg0) {
		try {
			return real.getClob(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Clob getClob(String arg0) {
		try {
			return real.getClob(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getConcurrency() {
		try {
			return real.getConcurrency();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public String getCursorName() {
		try {
			return real.getCursorName();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Date getDate(int arg0) {
		try {
			return real.getDate(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Date getDate(String arg0) {
		try {
			return real.getDate(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Date getDate(int arg0, Calendar arg1) {
		try {
			return real.getDate(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Date getDate(String arg0, Calendar arg1) {
		try {
			return real.getDate(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public double getDouble(int arg0) {
		try {
			return real.getDouble(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public double getDouble(String arg0) {
		try {
			return real.getDouble(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getFetchDirection() {
		try {
			return real.getFetchDirection();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getFetchSize() {
		try {
			return real.getFetchSize();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public float getFloat(int arg0) {
		try {
			return real.getFloat(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public float getFloat(String arg0) {
		try {
			return real.getFloat(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getInt(int arg0) {
		try {
			return real.getInt(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getInt(String arg0) {
		try {
			return real.getInt(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public long getLong(int arg0) {
		try {
			return real.getLong(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public long getLong(String arg0) {
		try {
			return real.getLong(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public ResultSetMetaData getMetaData() {
		try {
			return real.getMetaData();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Object getObject(int arg0) {
		try {
			return real.getObject(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Object getObject(String arg0) {
		try {
			return real.getObject(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Object getObject(int arg0, Map<String, Class<?>> arg1) {
		try {
			return real.getObject(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Object getObject(String arg0, Map<String, Class<?>> arg1) {
		try {
			return real.getObject(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Ref getRef(int arg0) {
		try {
			return real.getRef(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Ref getRef(String arg0) {
		try {
			return real.getRef(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getRow() {
		try {
			return real.getRow();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public short getShort(int arg0) {
		try {
			return real.getShort(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public short getShort(String arg0) {
		try {
			return real.getShort(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Statement getStatement() {
		try {
			return real.getStatement();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public String getString(int arg0) {
		try {
			return real.getString(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public String getString(String arg0) {
		try {
			return real.getString(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Time getTime(int arg0) {
		try {
			return real.getTime(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Time getTime(String arg0) {
		try {
			return real.getTime(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Time getTime(int arg0, Calendar arg1) {
		try {
			return real.getTime(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Time getTime(String arg0, Calendar arg1) {
		try {
			return real.getTime(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Timestamp getTimestamp(int arg0) {
		try {
			return real.getTimestamp(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Timestamp getTimestamp(String arg0) {
		try {
			return real.getTimestamp(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Timestamp getTimestamp(int arg0, Calendar arg1) {
		try {
			return real.getTimestamp(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Timestamp getTimestamp(String arg0, Calendar arg1) {
		try {
			return real.getTimestamp(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public int getType() {
		try {
			return real.getType();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public URL getURL(int arg0) {
		try {
			return real.getURL(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public URL getURL(String arg0) {
		try {
			return real.getURL(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public InputStream getUnicodeStream(int arg0) {
		try {
			return real.getUnicodeStream(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public InputStream getUnicodeStream(String arg0) {
		try {
			return real.getUnicodeStream(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public SQLWarning getWarnings() {
		try {
			return real.getWarnings();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void insertRow() {
		try {
			real.insertRow();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean isAfterLast() {
		try {
			return real.isAfterLast();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean isBeforeFirst() {
		try {
			return real.isBeforeFirst();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean isFirst() {
		try {
			return real.isFirst();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean isLast() {
		try {
			return real.isLast();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean last() {
		try {
			return real.last();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void moveToCurrentRow() {
		try {
			real.moveToCurrentRow();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void moveToInsertRow() {
		try {
			real.moveToInsertRow();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean next() {
		try {
			return real.next();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean previous() {
		try {
			return real.previous();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void refreshRow() {
		try {
			real.refreshRow();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean relative(int arg0) {
		try {
			return real.relative(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean rowDeleted() {
		try {
			return real.rowDeleted();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean rowInserted() {
		try {
			return real.rowInserted();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean rowUpdated() {
		try {
			return real.rowUpdated();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setFetchDirection(int arg0) {
		try {
			real.setFetchDirection(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setFetchSize(int arg0) {
		try {
			real.setFetchSize(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateArray(int arg0, Array arg1) {
		try {
			real.updateArray(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateArray(String arg0, Array arg1) {
		try {
			real.updateArray(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateAsciiStream(int arg0, InputStream arg1, int arg2) {
		try {
			real.updateAsciiStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateAsciiStream(String arg0, InputStream arg1, int arg2) {
		try {
			real.updateAsciiStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBigDecimal(int arg0, BigDecimal arg1) {
		try {
			real.updateBigDecimal(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBigDecimal(String arg0, BigDecimal arg1) {
		try {
			real.updateBigDecimal(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBinaryStream(int arg0, InputStream arg1, int arg2) {
		try {
			real.updateBinaryStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBinaryStream(String arg0, InputStream arg1, int arg2) {
		try {
			real.updateBinaryStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBlob(int arg0, Blob arg1) {
		try {
			real.updateBlob(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBlob(String arg0, Blob arg1) {
		try {
			real.updateBlob(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBoolean(int arg0, boolean arg1) {
		try {
			real.updateBoolean(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBoolean(String arg0, boolean arg1) {
		try {
			real.updateBoolean(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateByte(int arg0, byte arg1) {
		try {
			real.updateByte(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateByte(String arg0, byte arg1) {
		try {
			real.updateByte(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBytes(int arg0, byte[] arg1) {
		try {
			real.updateBytes(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateBytes(String arg0, byte[] arg1) {
		try {
			real.updateBytes(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateCharacterStream(int arg0, Reader arg1, int arg2) {
		try {
			real.updateCharacterStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateCharacterStream(String arg0, Reader arg1, int arg2) {
		try {
			real.updateCharacterStream(arg0, arg1, arg2);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateClob(int arg0, Clob arg1) {
		try {
			real.updateClob(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateClob(String arg0, Clob arg1) {
		try {
			real.updateClob(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateDate(int arg0, Date arg1) {
		try {
			real.updateDate(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateDate(String arg0, Date arg1) {
		try {
			real.updateDate(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateDouble(int arg0, double arg1) {
		try {
			real.updateDouble(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateDouble(String arg0, double arg1) {
		try {
			real.updateDouble(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateFloat(int arg0, float arg1) {
		try {
			real.updateFloat(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateFloat(String arg0, float arg1) {
		try {
			real.updateFloat(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateInt(int arg0, int arg1) {
		try {
			real.updateInt(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateInt(String arg0, int arg1) {
		try {
			real.updateInt(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateLong(int arg0, long arg1) {
		try {
			real.updateLong(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateLong(String arg0, long arg1) {
		try {
			real.updateLong(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateNull(int arg0) {
		try {
			real.updateNull(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateNull(String arg0) {
		try {
			real.updateNull(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateObject(int arg0, Object arg1) {
		try {
			real.updateObject(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateObject(String arg0, Object arg1) {
		try {
			real.updateObject(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateObject(int arg0, Object arg1, int arg2) {
		try {
			real.updateObject(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateObject(String arg0, Object arg1, int arg2) {
		try {
			real.updateObject(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateRef(int arg0, Ref arg1) {
		try {
			real.updateRef(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateRef(String arg0, Ref arg1) {
		try {
			real.updateRef(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateRow() {
		try {
			real.updateRow();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateShort(int arg0, short arg1) {
		try {
			real.updateShort(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateShort(String arg0, short arg1) {
		try {
			real.updateShort(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateString(int arg0, String arg1) {
		try {
			real.updateString(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateString(String arg0, String arg1) {
		try {
			real.updateString(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateTime(int arg0, Time arg1) {
		try {
			real.updateTime(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateTime(String arg0, Time arg1) {
		try {
			real.updateTime(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateTimestamp(int arg0, Timestamp arg1) {
		try {
			real.updateTimestamp(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void updateTimestamp(String arg0, Timestamp arg1) {
		try {
			real.updateTimestamp(arg0, arg1);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public boolean wasNull() {
		try {
			return real.wasNull();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Connection getConnection() {
		try {
			return real.getConnection();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public ResultSet getOriginal() {
		try {
			return real.getOriginal();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public ResultSet getOriginalRow() {
		try {
			return real.getOriginalRow();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Object[] getParams() {
		try {
			return real.getParams();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setMetaData(RowSetMetaData arg0) {
		try {
			real.setMetaData(arg0);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public void setTypeMap(Map<String, Class<?>> map) throws SQLException {
		try {
			real.setTypeMap(map);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Rows nextPageRows() throws SQLException {
		try {
			return real.nextPageRows();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}

	public Rows prePageRows() throws SQLException {
		try {
			return real.prePageRows();
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}
	
	public Object toHandle(ResultSetHandler rsh) throws SQLException {
		try {
			return real.toHandle(rsh);
		} catch (SQLException e) {
			throw switchException(e) ;
		}
	}	

}
