package com.bleujin.framework.db;

import java.io.IOException;
import java.io.Serializable;
import java.io.Writer;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collection;

import javax.sql.RowSet;
import javax.sql.RowSetInternal;

import com.bleujin.framework.db.bean.ResultSetHandler;

/**
 * CLOB precessing and Adapter Pattern
 * <p>Title: Database framework</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: I-ON Communications</p>
 * @author bleujin
 * @version 1.0
 */

public interface Rows extends RowSet, RowSetInternal, Serializable, Cloneable {
    public static String DEFAULT_ROOT_NAME = "RowSet";
    public static String DEFAULT_ROW_NAME = "row";

    public static String PUBLIC_DTD_ID = "-//Sun Microsystems, Inc.//DTD RowSet//EN" ;
    public static String SYSTEM_ID = "http://java.sun.com/j2ee/dtds/RowSet.dtd" ;

    public int getRowCount() ;
    public void populate(ResultSet rs) throws SQLException ;
    public void populate(ResultSet rs, int skip, int length) throws SQLException ;

    public Rows setNextRows(Rows rows) ;
    public Rows getNextRows() ;

    public void setXmlWriter(IXmlWriter writer) throws SQLException  ;
    public void writeXml(Writer writer, IXmlWriter xmlWriter) throws SQLException;
    public void writeXml(Writer writer) throws SQLException, IOException ;
    public IXmlWriter getIXmlWriter() throws SQLException ;

    public boolean getShowDeleted() throws SQLException ;
    public String getTableName() throws SQLException ;
    public void setTableName(String name) throws SQLException ;

    public String getDefaultString(String col1, String defaultString) throws SQLException ;
    
    public Row firstRow() ;
    public Rows nextPageRows() throws SQLException;
    public Rows prePageRows()  throws SQLException;

    public Collection toCollection() throws SQLException ;
    public Object toHandle(ResultSetHandler rsh) throws SQLException ;
    
}