package com.bleujin.framework.db.bean.handlers;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import com.bleujin.framework.db.bean.BasicRowProcessor;
import com.bleujin.framework.db.bean.ResultSetHandler;
import com.bleujin.framework.db.bean.RowProcessor;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: I-ON Communications</p>
 * @author bleujin
 * @version 1.0
 */

public class LimitMapListHandler implements ResultSetHandler {

    final int skipRow ;
    final int limitRow ;

    private RowProcessor convert = BasicRowProcessor.instance();

    public LimitMapListHandler() {
        this(0, 10) ;
    }

    public LimitMapListHandler(int skipRow, int limitRow) {
        super();
        this.skipRow = skipRow ;
        this.limitRow = limitRow ;
    }

    public Object handle(ResultSet rs) throws SQLException {

        List results = new ArrayList();

        // skip
        for (int i = 0; i < this.skipRow; i++) {
            rs.next();
        }
        Hashtable a = new Hashtable() ;

        for (int i = 0; rs.next() && (this.limitRow == 0 || i < this.limitRow) ; i++) {
            results.add(this.convert.toMap(rs));
        }

        return results;
    }

}
