package com.bleujin.framework.db.fake;

import java.sql.Connection;
import java.sql.SQLException;

import com.bleujin.framework.db.IDBController;
import com.bleujin.framework.db.manager.DBManager;
import com.bleujin.framework.db.procedure.CombinedUserProcedures;
import com.bleujin.framework.db.procedure.IParameterQueryable;
import com.bleujin.framework.db.procedure.IQueryable;
import com.bleujin.framework.db.procedure.IUserCommand;
import com.bleujin.framework.db.procedure.IUserCommandBatch;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.framework.db.procedure.IUserProcedureBatch;
import com.bleujin.framework.db.procedure.RepositoryService;
import com.bleujin.framework.db.procedure.UserProcedures;

public class FakeDBController implements IDBController{

	private String name ;
	private Connection conn ;
	private DBManager dbm ;

	public FakeDBController(Connection conn){
		this.conn = conn ;
		this.name = "Fake Controller" ;
		this.dbm = new FakeDBManager(conn) ;
	}
	
	public CombinedUserProcedures createCombinedUserProcedures(String name) {
		return getRepositoryService().createCombinedUserProcedures(this, name);
	}

	public IParameterQueryable createParameterQuery(String proc) {
		return getRepositoryService().createParameterQuery(this, proc);
	}

	public IUserCommand createUserCommand(String proc) {
		return getRepositoryService().createUserCommand(this, proc);
	}

	public IUserCommandBatch createUserCommandBatch(String procSQL) {
		return getRepositoryService().createUserCommandBatch(this, procSQL);
	}

	public IUserProcedure createUserProcedure(String proc) {
		return getRepositoryService().createUserProcedure(this, proc);
	}

	public IUserProcedureBatch createUserProcedureBatch(String procSQL) {
		return getRepositoryService().createUserProcedureBatch(this, procSQL);
	}

	public UserProcedures createUserProcedures(String name) {
		return getRepositoryService().createUserProcedures(this, name);
	}

	public void destroySelf() throws SQLException {
		// no action
	}

	public DBManager getDBManager() {
		return this.dbm;
	}

	public String getName() {
		return name;
	}

	public void handleServant(long start, long end, IQueryable queryable, int queryCommand) {
		// no action
	}

	public void initSelf() throws SQLException {
		// no action
	}
	
	private RepositoryService getRepositoryService() {
		return dbm.getRepositoryService();
	}
}


