package com.bleujin.framework.db.manager;

import java.sql.Connection;
import java.sql.SQLException;


public class Oracle9iCacheDBManagerWithRetry extends Oracle9iCacheDBManager{

    final static private int MAX_TRY = 10 ;

    Oracle9iCacheDBManagerWithRetry() {
        super("jdbc:oracle:thin:@ics4db.i-on.net:8080:DB9I", "odin", "odin");
    }

    public Oracle9iCacheDBManagerWithRetry(String jdbcURL, String user, String passwd) {
        this(jdbcURL, user, passwd, 20);
    }

    public Oracle9iCacheDBManagerWithRetry(String jdbcURL, String user, String passwd, int connectionLimit) {
        super(jdbcURL, user, passwd, connectionLimit);
    }

    public Connection getConnection() throws SQLException {
        return getConnection(MAX_TRY) ;
    }

    private Connection getConnection(int trycount) throws SQLException {
        if (trycount <= 0) {
            throw new SQLException("Cant connect during " + MAX_TRY + " retry. confirm environment information of database");
        }
        Connection conn = null ;
        try {
            conn = super.getConnection();
        } catch (SQLException ex) {
            System.out.println("Cant get Database Connection[Retry " + (MAX_TRY - trycount + 1) + "]" + ex.getMessage());
            freeConnection(conn);
            conn = getConnection(--trycount) ;
        } finally{
        }
        return conn ;
    }

}
