package com.bleujin.framework.db.manager;

import java.sql.Connection;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import com.bleujin.framework.db.procedure.RepositoryService;


/**
 * <p>Title: WAS(Web Application Server) DNS ϴ  ⺻ DBManager</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: I-ON Communications</p>
 * @author bleujin
 * @version 1.0
 */

public class WASDBManager extends DBManager
{

//    protected String datasourceName = "OracleLocalHost"; // web logic DataSource Name
    protected String datasourceName = null; // web logic DataSource Name
    protected Context ctx;
    protected DataSource ds;
    String dBName ;

    public WASDBManager(String dataSourceName, String dBName) {
        super("","","","") ;

        this.datasourceName = dataSourceName;
        this.dBName = dBName ;
    }

    protected void myInitPool() throws SQLException {
        try {
            ctx = new InitialContext();
            ds = ( javax.sql.DataSource )ctx.lookup( datasourceName );
        } catch ( NamingException ex ) {
            new SQLException(ex.getMessage()) ;
        }

    }

    public Connection getConnection() throws SQLException {
        return ds.getConnection();
    }

    public int getDBManagerType() {
        return DBType.WASDBManager;
    }

    protected void myDestroyPool() throws SQLException
    {
        try {
			ctx.unbind(datasourceName) ;
		} catch (NamingException ignore) {
			ignore.printStackTrace();
		}
        ds = null ;

		try {
			ctx.close() ;
		} catch (NamingException ignore) {
			ignore.printStackTrace();
		}
    }

    public String getDBType() {
        return dBName;
    }

    public RepositoryService getRepositoryService() {
        RepositoryService result ;
        if (dBName.equals(DBType.OracleDBName)) return RepositoryService.ORACLE;
        else if (dBName.equals(DBType.MSSQLDBName)) return RepositoryService.MSSQL ;
        else
            throw new IllegalArgumentException("not supported db type") ;
    }

}
