package com.bleujin.framework.db.procedure;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;

import org.apache.commons.io.IOUtils;

import com.bleujin.framework.db.IDBController;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author bleujin
 * @version 1.0
 */

public class MSSQLUserCommand extends UserCommand {

    MSSQLUserCommand(IDBController dc, String strSQL ) {
        this(dc, strSQL, QueryType.USER_COMMAND) ;
    }

    MSSQLUserCommand(IDBController dc, String strSQL, int queryType ) {
        super(dc, strSQL, queryType) ;
    }

    protected Statement getStatement(){
        return pstmt ;
    }

    public void printPlan(OutputStream output) throws SQLException {
    	MSSQLUserCommandPlan plan = new MSSQLUserCommandPlan(getDBController(), this) ;
    	plan.printPlan(output) ;
    }
    
    protected int myUpdate(Connection conn) throws SQLException {
        int updateCount;
        try {
            pstmt = conn.prepareStatement(getProcSQL());

            for (int i = 0, last = getParams().size(); i < last ;i++) {
                setParam(pstmt, i, getParams().get(i));
            }
            updateCount = pstmt.executeUpdate();
        } finally{
			closeSilence(pstmt) ;
        }
        return updateCount ;
    }

    protected void setParam(PreparedStatement pstmt, int i, Object obj) throws SQLException {
    	
        if (isNull(i)) {
            pstmt.setNull(i + 1, getType(i));
        } else if ( (getType(i) == Types.BLOB) && (obj instanceof InputStream)){
        	InputStream input = (InputStream)obj ;
        	try {
				byte[] bytes = IOUtils.toByteArray(input);
				pstmt.setBinaryStream(i+1, new ByteArrayInputStream(bytes), bytes.length) ;
				//pstmt.setBytes(i+1, bytes) ;
			} catch (IOException e) {
				throw new SQLException(e.getMessage()) ;
			} finally {
				try {input.close();} catch(IOException ignore){} ;
			}
        } else {
            pstmt.setObject(i + 1, obj);
        }
    }

}
