package com.bleujin.framework.db.procedure;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Writer;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import oracle.jdbc.driver.OracleCallableStatement;
import oracle.jdbc.driver.OracleTypes;
import oracle.sql.BLOB;
import oracle.sql.CLOB;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.ArrayUtils;

import com.bleujin.framework.db.IDBController;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author bleujin
 * @version 1.0
 */

public class Oracle8iUserProcedure extends OracleUserProcedure{

	private OracleCallableStatement cstmt ;
    Oracle8iUserProcedure(IDBController dc, String procSQL) {
        super(dc, procSQL) ;
    }
    
    protected Statement getStatement(){
        return this.cstmt ;
    }
    
    protected int myUpdate(Connection conn) throws SQLException {
        int updateRow = 0 ;
        try {

            cstmt = ( OracleCallableStatement )conn.prepareCall( "{? = call " + getProcedureSQL() + "}" );
            cstmt.registerOutParameter( 1, OracleTypes.NUMBER );

            setParam(conn, getParams().toArray(), ArrayUtils.toPrimitive((Integer[])getTypes().toArray()), OracleQueryUtils.PROCEDURE_LOC );

            cstmt.executeUpdate();
            updateRow = cstmt.getInt( 1 );

            writeLobType(conn, cstmt, getParams().toArray(), ArrayUtils.toPrimitive((Integer[])getTypes().toArray()) );
        } catch ( IOException ex ) {
            throw new SQLException( ex.getMessage() );
        } catch ( SQLException ex ) {
            throw new SQLException( getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode() );
        } finally {
      	   closeSilence(cstmt) ;
        }
        return updateRow;
    }


    private void setParam(Connection conn, Object[] params, int[] types, int mediateLoc) throws SQLException, IOException {
        for(int i = 0, last = params.length; i < last; i++) {
            Object obj = params[i];
            int type = types[i];
            if(obj == null) {
                cstmt.setNull(i + mediateLoc, types[i]);
            } else if(isClobType(type)) {
                cstmt.setNull(i+2, OracleTypes.CLOB);
                cstmt.registerOutParameter(i+2, OracleTypes.CLOB);
            } else if(isBlobType(type)) {
                cstmt.setNull(i+2, OracleTypes.BLOB);
                cstmt.registerOutParameter(i+2, OracleTypes.BLOB);
            } else {
                cstmt.setObject(i + mediateLoc, obj);
            }
        }

    }

    private void writeLobType(Connection conn, OracleCallableStatement ostmt, Object[] params, int[] types) throws IOException, SQLException {

        for ( int i = 0; i < params.length; i++ ) {
            if (! isClobType(types[i])) continue ;
            CLOB clob = ostmt.getCLOB( i + 2 );
            Writer writer = ( ( CLOB )clob ).getCharacterOutputStream();
            writer.write( ( ( String )params[i]).toCharArray() );
            writer.flush();
            writer.close();
        }
        for ( int i = 0; i < params.length; i++ ) {
            if (! isBlobType(types[i])) continue ;
            BLOB blob = ostmt.getBLOB( i + 2 );
            InputStream is = (InputStream)params[i] ;
            OutputStream os = blob.getBinaryOutputStream() ;
            IOUtils.copy(is, os) ;
            os.flush();
            os.close();
        }
    }



}

//    before version...
//    protected int execUpdate(Connection conn) throws SQLException {
//        int updateRow = 0 ;
//        try {
//
//            cstmt = ( OracleCallableStatement )conn.prepareCall( "{? = call " + getProcedureSQL() + "}" );
//            cstmt.registerOutParameter( 1, OracleTypes.NUMBER );
//
//            for ( int i = 0; i < getParams().size(); i++ ) {
//                setParam( cstmt, i );
//            }
//            cstmt.executeUpdate();
//            updateRow = cstmt.getInt( 1 );
//
//            // insert Ȥ update 1 ̻ Ͽ Clob or Blob Type ...
//            if ( updateRow > 0 && hasLobType() ) {
//                writeLobType(cstmt );
//            }
//        } catch ( IOException ex ) {
//            throw new SQLException( ex.getMessage() );
//        } catch ( SQLException ex ) {
//            throw new SQLException( getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode() );
//        } finally {
//            if ( cstmt != null ) cstmt.close();
//            cstmt = null ;
//        }
//        return updateRow;
//    }
//    private void writeLobType(OracleCallableStatement modifyps ) throws IOException, SQLException {
//        for ( int i = 0; i < getClobParamCount(); i++ ) {
//            CLOB clob = modifyps.getCLOB( getClobParamIndex( i ) + 2 );
//            Writer writer = ( ( CLOB )clob ).getCharacterOutputStream();
//            writer.write( ( ( String )getParams().get( getClobParamIndex( i ) ) ).toCharArray() );
//            writer.flush();
//            writer.close();
//        }
//        for ( int i = 0; i < getBlobParamCount(); i++ ) {
//            Blob blob = modifyps.getBlob( getBlobParamIndex( i ) + 2 );
//            OutputStream blobOutputStream = ( ( oracle.sql.BLOB )blob ).getBinaryOutputStream();
//            File file = new File( ( String )getParams().get( getBlobParamIndex( i ) ) ); // filename
//            InputStream fileStream = new FileInputStream( file );
//
//            byte[] buffer = new byte[4 * 1024];
//            int nread = 0; // Number of bytes read
//            while ( ( nread = fileStream.read( buffer ) ) != -1 ) { // Read from file
//                blobOutputStream.write( buffer, 0, nread ); // Write to Blob
//            }
//            fileStream.close();
//            blobOutputStream.close();
//        }
//    }

//    Lob Insert or Updateϴ Function ۼ 
//    CREATE OR REPLACE FUNCTION SCOTT.Insert_Test_Clob5(
//            clob_Id in out Number,
//            clob_text1 in out CLOB,
//            blob_img1 in out BLOB,
//            clob_text2 in out CLOB,
//            blob_img2 in out BLOB
//            )return NUMBER
//    IS
//            v_rowid varchar(40) ;
//    BEGIN
//            Insert into clobtest(a, b, c, d, e) values(clob_Id, empty_clob(), empty_blob(), empty_clob(), empty_blob()) returning rowid into v_rowid ;
//
//            SELECT B, C, D, E INTO clob_text1, blob_img1, clob_text2, blob_img2
//            FROM clobtest
//            WHERE rowid = v_rowid ;
//
//    return 1;
//    END;

//    Code Sample
//    UserProcedure upt = new UserProcedure( "Insert_Test_Clob5(?,?,?,?,?)" );
//    upt.addParam( 0, 999);
//    upt.addClob( 1, clob.toString() );
//    upt.addBlob( 2, "c:\\odbcconf.log" );
//    upt.addClob( 3, clob.toString() );
//    upt.addBlob( 4, "c:\\odbcconf.log" );
//    dc.execProcedureUpdate( upt )



//            Blob blob = null ;
//            if(rs.next()){
//                blob = rs.getBlob(3) ;
//            }
//            InputStream from = blob.getBinaryStream();
//            FileOutputStream to = new FileOutputStream("c:\\temp2.log");
//
//            byte[] buffer = new byte[4096]; // buffer holding bytes to be transferred
//            int nbytes = 0;  // Number of bytes read
//            while( (nbytes = from.read(buffer)) != -1 ) // Read from Blob stream
//                to.write(buffer, 0, nbytes);     // Write to file stream
//            to.flush();
//            to.close();
//            from.close();

//        } catch ( IOException ex ) {
//            throw new SQLException( "Exception thrown in execProcedureQuery() method of OracleDBManager Class\n" + ex.toString());
