package com.bleujin.framework.db.procedure;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import oracle.jdbc.driver.OraclePreparedStatement;

import com.bleujin.framework.db.IDBController;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author bleujin
 * @version 1.0
 */


public class OracleUserCommandBatch extends UserCommandBatch{

    OracleUserCommandBatch(IDBController dc, String strSQL) {
        super(dc, strSQL) ;
    }

    protected Statement getStatement(){
        return pstmt ;
    }

    protected int myUpdate(Connection conn) throws SQLException{
        int updateCount;
        try {
            pstmt = (OraclePreparedStatement)conn.prepareStatement(getProcSQL());
            pstmt.clearBatch();

            ((OraclePreparedStatement)pstmt).setExecuteBatch(100);
            setParams(conn);
//            int[] count = pstmt.executeBatch();
//            updateCount = count.length ;
            updateCount = ((OraclePreparedStatement)pstmt).sendBatch() ;

            pstmt.close();
            pstmt = null ;

        } catch (IOException ex) {
            throw new SQLException(ex.getMessage()) ;
        } catch (SQLException ex) {
            throw ex ;
        } finally{
      	   closeSilence(pstmt) ;
        }
        return updateCount ;
    }

    private void setParams(Connection conn) throws IOException, SQLException {
        Object[][] values = getParamsAsArray(); // [a][b] a : rows, b : column
        for (int row = 0, rlast = values.length > 0 ? values[0].length : 0 ; row < rlast ; row++) {
            List list = new ArrayList() ;
            for ( int col = 0, clast = values.length ; col < clast ; col++ ) {
                Object obj = values[col][row] ;
                list.add(obj);
            }
            OracleQueryUtils.setParam(conn, pstmt, list, getTypes(), OracleQueryUtils.COMMAND_LOC );
//            pstmt.addBatch();
            pstmt.executeUpdate();
        }

    }

}
