package com.bleujin.framework.db.procedure;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import oracle.jdbc.driver.OracleCallableStatement;

import com.bleujin.framework.db.IDBController;

public class OracleUserProcedureBatch extends UserProcedureBatch {

    protected OracleCallableStatement cstmt = null ;

    OracleUserProcedureBatch(IDBController dc, String procSQL) {
        super(dc, procSQL) ;
    }

    protected Statement getStatement(){
        return cstmt ;
    }

    protected int myUpdate(Connection conn) throws SQLException {
        int[] updateRow;

        try {
            String procSQL = getProcSQL().replace('@', '.');
            cstmt = (OracleCallableStatement) conn.prepareCall("{call " + procSQL + "}");
            Object[][] values = getParamsAsArray(); // [a][b] a : rows, b : column

            for (int row = 0, rlast = values.length > 0 ? values[0].length : 0 ; row < rlast ; row++) {
                List list = new ArrayList() ;
                for ( int col = 0, clast = values.length ; col < clast ; col++ ) {
                    Object obj = values[col][row] ;
                    list.add(obj);
                }
                OracleQueryUtils.setParam(conn, cstmt, list, getTypes(), OracleQueryUtils.COMMAND_LOC );

                cstmt.addBatch();
            }

            updateRow = cstmt.executeBatch();
            cstmt.close();
        } catch (IOException ex) {
            throw new SQLException(ex.getMessage());
        } catch (SQLException ex) {
            throw ex ;
        } finally {
      	   closeSilence(cstmt) ;
        }

        return updateRow.length;
    }

}
