package com.bleujin.framework.db.procedure;

import org.apache.commons.lang.StringUtils;

import com.bleujin.framework.db.IDBController;

/**
 * <p>
 * Title: Procedure Query
 * </p>
 * <p>
 * Description: execProcedureQuery, Update ϱ  Procedure Query .
 * </p>
 * <p>
 * Copyright: Copyright (c) 2003
 * </p>
 * <p>
 * Company: I-ON Communications
 * </p>
 * 
 * @author bleujin
 * @version 1.0
 */

public abstract class UserProcedure extends ParameterQueryable implements IUserProcedure {

	protected UserProcedure(IDBController dc, String procSQL) {
		super(dc, procSQL, QueryType.USER_PROCEDURE);
	}

	UserProcedure(IDBController dc, String procSQL, int queryType) {
		super(dc, procSQL, queryType);
	}

	public String getProcName() {
		return StringUtils.deleteWhitespace(StringUtils.substringBefore(this.getProcSQL(), "("));
	}

	public String toString() {
		return getProcFullSQL();
	}

}
