package com.bleujin.framework.db.querybuilder;

import java.util.ArrayList;
import java.util.Vector;

import com.bleujin.framework.util.StringUtil;


public class MSSQLQueryBuilder extends QueryBuilder
{
    boolean isRightOuterJoin = false;
    boolean isLeftOuterJoin = false;
    ArrayList outerCondition = new ArrayList();

    public MSSQLQueryBuilder() {
        super();
    }

    public MSSQLQueryBuilder(String aliasName) {
        super(aliasName);
    }

    public void init() {
        isRightOuterJoin = false;
    }

    protected String makeSelect() {
        return "select" + makeLimit();
    }

    protected String makeColumn() {
        return super.makeColumn();
    }

    protected String makeWhere() {
//        String result = "" ;
//        for(int i=0, last = relations.size() ; i < last ; i++)
//        {
//			if (i == last - 1){
//				result += relations.get(i) ;
//			} else{
//				result += relations.get(i) + " and ";
//			}
//        }
//        return " where " + result + makeFilter() ;
        String result = "";
        int i;
        if(relations.size() > 0) {
            for(i = 0; i < relations.size() - 1; i++) {
                result += relations.get(i) + " and ";
            }
            result += relations.get(i);
            return " where " + result + makeFilter();
        } else if(relations.size() == 0 && filters.size() > 0) {
            return " where " + makeFilter();
        } else {
            return "";
        }

    }

    private String makeFilter() {
        String result = relations.size() * filters.size() > 0 ? " and " : "";
        result = result + makeStringFromArray(filters, " and ", "");
//        if (result.length() > 0 ) {
//            result = result ;
//        }
        return result;
    }

    protected String makeLimit() {
        if(limit > 0)
            return " top " + String.valueOf(limit);
        else
            return " top 100 percent ";
    }

    protected String makeFrom() {

        if(isRightOuterJoin) {
            String result = "(" + ((SQLExpression)querys.get(0)).getQueryString() + ") " + this.aliasName + "0" + " Right Outer Join ";
            result += "(" + ((SQLExpression)querys.get(1)).getQueryString() + ") " + this.aliasName + "1";

            return "from " + result + makeOuterJoinCondition();
        } else if(isLeftOuterJoin) {
            String result = "(" + ((SQLExpression)querys.get(0)).getQueryString() + ") " + this.aliasName + "0" + " Left Outer Join ";
            result += "(" + ((SQLExpression)querys.get(1)).getQueryString() + ") " + this.aliasName + "1";

            return "from " + result + makeOuterJoinCondition();
        } else {
            return super.makeFrom();
        }
    }

    private String makeOuterJoinCondition() {
        String result = "";
        for(int i = 0, last = outerCondition.size(); i < last; i++) {
            if(i == last - 1) {
                result += (String)outerCondition.get(i);
            } else {
                result += (String)outerCondition.get(i) + " and ";
            }
        }
        return " On " + result;
    }

    public void setRightOuterRelation(int table1_index, int table2_index, String table1_colName, String table2_colName) {
        isRightOuterJoin = true;
        String outerJointCondtion = this.aliasName + String.valueOf(table1_index) + "." + table1_colName + " = " + this.aliasName + String.valueOf(table2_index) + "." + table1_colName;
        outerCondition.add(outerJointCondtion);
    }

    public void setLeftOuterRelation(int table1_index, int table2_index, String table1_colName, String table2_colName) {
        isLeftOuterJoin = true;
        String outerJointCondtion = this.aliasName + String.valueOf(table1_index) + "." + table1_colName + " = " + this.aliasName + String.valueOf(table2_index) + "." + table1_colName;
        outerCondition.add(outerJointCondtion);
    }

    public String _SQLOfKeyword(String QB_0_artId, String val) {
        return QB_0_artId + " in (select artId from (select dbo.Utils@getIndexString(arrKeyWord, divString, no1) keywordNm from (" +
            "select '" + val + "' arrKeyWord, ';' divString) t1, copy_tblc ct where ct.no1 <= dbo.Utils@getIncludeCount(arrKeyWord, divString)) x1, article_keyword_tblc x2 where x2.keywordNm like x1.keywordNm)";
    }

    public String _SQLOfRelation(String catId, String artId, String retKindCd, String QB_0_catId, String QB_0_artId) {
        return QB_0_catId + " in (select lowerCatId from article_rel_tblc where upperCatId = '" + catId + "' and upperArtId = " + artId + " and relKindCd like '" + retKindCd + "%') and " +
            QB_0_artId + " in (select lowerArtId from article_rel_tblc where upperCatId = '" + catId + "' and upperArtId = " + artId + " and relKindCd like '" + retKindCd + "%')";
    }

    public String _SQLOFToday(String conditionType, String col, String op, String refDateStr, String oper, String num, String subQueryOfArrCatId) {
        if(conditionType.equalsIgnoreCase("logical")) {
            return "substring(" + col + ",1,8) " + op +
                "(select decode(substring(max(" + col + "),1,8)," + "substring('" + refDateStr + "',1,8)," +
                " convert(varchar(8), dbo.Utils@convertDefaultFormedDate('" + refDateStr + "') " + oper + " " + num + ", 112)," +
                " convert(varchar(8), dbo.Utils@convertDefaultFormedDate('" + refDateStr + "') " + oper + " " + num +
                " - (dbo.Utils@convertDefaultFormedDate('" + refDateStr + "') - dbo.Utils@convertDefaultFormedDate(max(" + col + "))), 112)) " +
                "from publish_general_vw " +
                "where catId in " + subQueryOfArrCatId + " and substring(" + col + ",1,8) <= substring('" + refDateStr + "',1,8) )";
        } else { // ostime
            return "substring(" + col + ",1,8) " + op +
                "convert(varchar(8), dbo.Utils@convertDefaultFormedDate('" + refDateStr + "') " + oper + " " + num + " , 112)";
        }

    }

    public String _SQLOfAFieldGeneralSearchCondition(String qbIndex, String afieldId, String afieldTypeCd, String op, String valExpression) {
        return
            " " + qbIndex + "." + "afieldId = '" + afieldId + "'" +
            " and " + qbIndex + "." + "dValue " + transOperator(op, valExpression, afieldTypeCd);

//            " " + qbIndex + "." + "afieldId = '" + afieldId + "'" +
//            " and (Case '" + afieldTypeCd + "' " +
//            "           When 'String'       Then " + qbIndex + "." + "ContForChar " +
//            "           When 'MultSelect'   Then " + qbIndex + "." + "ContForChar " +
//            "           When 'LongString'   Then " + qbIndex + "." + "ContForChar " +
//            "           When 'Boolean'      Then " + qbIndex + "." + "ContForBoolean " +
//            "           When 'Image'        Then " + qbIndex + "." + "ContForImg " +
//            "           When 'File'         Then " + qbIndex + "." + "ContForFile " +
//            "           When 'Currency'     Then cast(" + qbIndex + "." + "ContForMoney as varchar(30)) " +
//            "           When 'Date'         Then dbo.Utils@convertDefaultFormedDay(" + qbIndex + "." + "ContForDate) " +
//            "           When 'Float'        Then cast(" + qbIndex + "." + "ContForFloat as varchar(30)) " +
//            "           When 'Number'       Then cast(" + qbIndex + "." + "ContForInt as varchar(30)) End) " + transOperator(op, valExpression, afieldTypeCd);
    }

    public String _SQLOfAFieldSpecialCaseSearchCondition(String qbIndex, String afieldId, String afieldTypeCd, String op, String valExpression) {
        return _SQLOfAFieldGeneralSearchCondition(qbIndex, afieldId, afieldTypeCd, op, valExpression);
    }

    public String _SQLOfAFieldAdvancedSearchCondition(String QB_0_artId, String afieldId, String afieldTypeCd, String op, String valExpression) {
        return "dbo.Afield@isCompare(" + QB_0_artId + ", '" + afieldId + "', '" + afieldTypeCd + "', '" + transOp(op) + "', '" + valExpression + "') = 1 ";
    }

    public String _SQLOfAFieldConvertedValue(String QB_0_artId, String col) {
        return "'" + col.toLowerCase() + "' + dbo.Afield@getConvertedValue(" + QB_0_artId + ", '" + col.toLowerCase() + "')";
    }

    public String _SQLOFAfieldVersioning(String QB_0_modSerNo, String QB_1_modSerNo) {
        return " and " + QB_0_modSerNo + " = " + QB_1_modSerNo;
    }

    public String _SQLOfMetaSearchCondition(String t1_catId, String col, String op, String val) {
        return " dbo.Site_Category@isCompare(" + t1_catId + ", '" + col + "', '" + transOp(op) + "', '" + val + "') = 1 ";
    }

    public String _SQLOfMetaConvertedValue(String t1_catId, String col) {
        return "dbo.Site_Category@getConvertedValue(" + t1_catId + ", '" + col + "')";
    }

    public String _SQLOfLimit(String sql, int limit) {
        return limit == 0 ? sql : "Select Top " + limit + " * From (" + sql + ") ltable";
    }

    public String _SQLOfCatFilter(String[] catId, boolean isBelow, Vector afieldIds) {
        if(isBelow) {
            if(afieldIds.size() == 0) {
                return "(select top 100 percent catId " +
                    " From catLivedDownStru_fn('" + StringUtil.join(catId) + "') " +
                    " group by catId order by catId )";
            } else {
                return "(select top 100 percent catId " +
                    " From catLivedDownStru_fn('" + StringUtil.join(catId) + "') c1 " +
                    " Where Exists ( Select 1 From category_afield_tblc Where catId = c1.catId and afieldId in (" + convertArrayToStartWithString((String[])afieldIds.toArray(new String[0])) + ") )" +
                    " group by catId order by catId )";
            }
        } else {
            return "(" + convertArrayToStartWithString(catId) + ")";
        }
    }

}
