package com.bleujin.framework.db.querybuilder;

import java.util.ArrayList;
import java.util.Vector;

public abstract class QueryBuilder extends SQLExpression
{
    public final static QueryBuilder NullBuilder = new NullQueryBuilder();

    private static long qBaliasNameCnt = 0;
    private static String newQueryBuilderAliasName() {
        // return "qb"+ qBaliasNameCnt++ + "_";
        return "qb_";
    }

    String aliasName = "x";
    ArrayList querys = new ArrayList();
    ArrayList relations = new ArrayList();

    public QueryBuilder() {
        this(QueryBuilder.newQueryBuilderAliasName());
    }

    public void init() {
    }


    private String hint = "" ;
    public void setHint(String hint){
        this.hint = hint ;
    }

    public String getHint(){
        return this.hint ;
    }

    public QueryBuilder(String aliasName) {
        this.aliasName = aliasName;
    }

    public void addSQLExpression(SQLExpression query) {
        querys.add(query);
    }

    public void setRelation(int table1_index, int table2_index, String table1_colName, String table2_colName) {
        String join = this.aliasName + String.valueOf(table1_index) + "." + table1_colName + " = " + this.aliasName + String.valueOf(table2_index) + "." + table1_colName;
        relations.add(join);
    }

    /**
     * @param table1_index 
     * @param table2_index  right outer join
     * @param table1_colName
     * @param table2_colName
     */
    public abstract void setRightOuterRelation(int table1_index, int table2_index, String table1_colName, String table2_colName);

    public abstract void setLeftOuterRelation(int table1_index, int table2_index, String table1_colName, String table2_colName);

    protected abstract String makeSelect();

    protected String makeFrom() {
        String result = makeStringFromArray(querys);
        return "from " + result;
    }

    protected String makeColumn() {
        String result = "";
        result = makeStringFromArray(columns, ", ", "*");

        return " " + result + " ";
    }

    protected abstract String makeWhere();

    protected String makeOrder() {
        return super.makeOrder();
    }

    protected abstract String makeLimit();

//	public abstract String getFunctionNameOfAFieldParsing() ;
//	public abstract String getFunctionNameOfConvertInt(String arg) ;
//	public abstract String getDummyTableName() ;

    protected String makeStringFromArray(ArrayList array) {
        String result = "";
        int i;
        for(i = 0; i < array.size() - 1; i++) {
            result += ((SQLExpression)array.get(i)).getQueryString() + " " + this.aliasName + String.valueOf(i) + ", ";
        }
        result += ((SQLExpression)array.get(i)).getQueryString() + " " + this.aliasName + String.valueOf(i);

        return result;
    }

    private void todoList() {
        /**@todo  row   .  ɼ  ֱٱ 1 ش.*/
        //   īװ 縦 ϰ Ҷ "row:*" Ѵ.
        //  ex) row:10

        /**@todo  below */
        //  ش īװ  īװ ϵ  ǥõȴ.
        //  ex) below:yes


//    continue ٷ  Action    ״ ϸ鼭   ƼŬ ͼ Ҷ Ѵ.
//
//    ׷Ƿ  ɼ  ActionStart ΰ ʿ.
//    ex) continue:yes
//
//    skip skip:N()  ŭ ƼŬ ǳʶٰ õȴ.
//    ex)skip:3 (ֱٱ 3 縦 ǳʶڴ.)


//    top top:yes ̸  Ӽ žΰ͸ ǥش.


//    close close:yes̸  Ӽ Ŭΰ͸ ǥش.


//    main ش  ׺̼ ɶ main:yes Էش.


//    child child:yes̸ Ϻα縦 Ѵ.


//    index ȣ  ش.
//    ex) index:asc(), index:desc()



//    catsearch ̴  search  īװ   鸸 ϰ  Ѵ.
//
//    ex) catsearch:̿ (īװ "̿" 縸 Ѵ.)
//        catsearch:ion (丮 "ion" 縸 Ѵ.)
//
//       ִ Parameters
//    name(īװ) , publishdir(丮)
//
//       ִ ڵ
//    =, <=, >=, <>, ==
//    <> :  ʴ, == : , = : , && : ߺҶ



//    datetype logical, ostime default ostime
//    logical    today ִ ڿ  ʴ´.
//
//    (ex) [--ActionStart,./,search:startdate=today,datetype:logical--]]
//    ܣ[--ArtTitle--]]<br>
//    [--ActionEnd--]]
//    =>Խó¥ ΰ͸  簡 Ʈ  ʴ ֱ  縦   Ͽ ÷ϰѴ.
//    BackNumberLoop  ֱ 縦  Ҷ Ѵ.


//    BackNumberLoop:yes: ѹ BackLoopStart   ÷׸ Ƚᵵ ڵ .
//    Date : ѹ  ¥ ش.
//    Order : ѹ   . Ʈ desc ̰ asc ָ  .
//    Term : ѹ δ. Ⱓ Ÿ   year, month, week   ִ.
//    Unit : ѹ δ.  ִ  month, week, day   ִ.
//    BackNumberDate : ѹ ֿܰ ȿ ѹη ٱ ̰  unit ¥ unit ǥ.
    }

    public abstract String _SQLOfKeyword(String QB_0_artId, String val);

    public abstract String _SQLOfRelation(String catId, String artId, String retKindCd, String QB_0_catId, String QB_0_artId);

    public abstract String _SQLOFToday(String conditionType, String col, String op, String refDateStr, String oper, String num, String subQueryOfArrCatId);

    public abstract String _SQLOfAFieldGeneralSearchCondition(String qbIndex, String afieldId, String afieldTypeCd, String op, String valExpression);

    public abstract String _SQLOfAFieldSpecialCaseSearchCondition(String qbIndex, String afieldId, String afieldTypeCd, String op, String valExpression);

    public abstract String _SQLOfAFieldAdvancedSearchCondition(String QB_0_artId, String afieldId, String afieldTypeCd, String op, String valExpression);

    public abstract String _SQLOfAFieldConvertedValue(String QB_0_artId, String col);

//    public String _SQLOfNumberTypeAFieldValue(String QB_1_afields, String col){
//        return "to_number(Article.getAfieldValue(" + QB_1_afields + ", '" + col + "'))" ;
//    }
//
//    public String _SQLOfNotNumberTypeAFieldValue(String QB_1_afields, String col){
//        return "Article.getAfieldValue(" + QB_1_afields + ", '" + col + "')" ;
//    }

    public abstract String _SQLOFAfieldVersioning(String QB_0_modSerNo, String QB_1_modSerNo);

    public String _SQLOfCategoryHasActionFieldCondition(String QB_0_catId, String arrCatIds) {
        return " and Exists ( Select 1 From category_afield_tblc Where catId = c1.catId and afield in " + arrCatIds + " )";
    }

    public abstract String _SQLOfMetaSearchCondition(String t1_catId, String col, String op, String val);

    public abstract String _SQLOfMetaConvertedValue(String t1_catId, String col);

    public abstract String _SQLOfLimit(String sql, int limit);

    public abstract String _SQLOfCatFilter(String[] catId, boolean b, Vector afieldIds);

    protected String transOperator(String op, String val, String afieldTypeCd) {
        String itsOp = "";
        String itsVal = "";

        if(afieldTypeCd.equals("Date")) {
            if(op.equals("==")) {
                itsOp = " like ";
                itsVal = val + "%";
            } else if(op.equals("=")) {
                itsOp = " like ";
                itsVal = val + "%";
            } else {
                itsOp = " " + op + " ";
                itsVal = val;
            }
        } else {
            if(op.equals("==")) {
                itsOp = " like ";
                itsVal = "%" + val + "%";
            } else {
                itsOp = " " + op + " ";
                itsVal = val;
            }
        }
        return itsOp + " '" + itsVal + "'";
    }

    protected String transOp(String op) {
        if(op.trim().equals("==")) {
            return "like";
        } else {
            return op.trim();
        }
    }

    protected String convertArrayToStartWithString(String[] catId) {
        String result = "";
        for(int i = 0; i < catId.length; i++) {
            if(i == catId.length - 1) {
                result = result + "'" + catId[i] + "'";
            } else {
                result = result + "'" + catId[i] + "',";
            }
        }
        return result;
    }
}
