package com.bleujin.framework.db.sample.dc;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.Rows;
import com.bleujin.framework.db.sample.SampleTestBase;
import com.bleujin.framework.db.servant.StdOutServant;

public class DCInit extends SampleTestBase{

	/*
	 * IDBController IQueryable ü ϴ 丮 Ȱ 
	 * ServantHandle   ִ.
	 * 
	 *   ߻ ϳ ҷ δٸ DBManager Wrappingؼ پ Ȳ Ʈ κ óϱ ؼ̴. 
	 *  
	 *   PooledConnection ٸ IDBController ϳ ؾ ǹ̰ ִ. 
	 *   α׷ init κп dc.initSelf ȣϰ
	 *  α׷ ÿ dc.destorySelf ȣؾ Ѵ. 
	 *    ȴٸ servlet init destoryÿ ȣϰ ɰ̴. 
	 *  PoolConnection   Ǳ  dc Ϲ Static    ׻ ׷  ʿ .   
	 */
	
	
	
	/*
	 * Ʒ   IDBController ϴ DBManager ͼ ο  IDBController  ִ.
	 * ׷ DBManager Owner DBController νϰ ֱ 
	 *  IDBController init Ȥ destroy Ѵٰ ؼ  DBController DBManger  ʴ´.
	 * 
	 * DBController Init ޼ҵ DBManger Ǯ ȰȭŰ Servant 带 ۽Ų. 
	 */
	public void testDCInit() throws Exception {
		DBController newDc = new DBController("newDC", dc.getDBManager()) ;
		newDc.initSelf() ;
		
		Rows rows = newDc.getRows("select 1 from copy_sample") ;
		newDc.destroySelf() ;

		assertEquals(1, rows.firstRow().getInt(1)) ;
	}
	
	
	/*
	 *  DBManger Owner init destory Ųٸ 
	 *   DBManger ϴ  DBController ؾ ұ ǹ  ִ. 
	 *   Connection Pool ٵ ̴. 
	 * 
	 * ׷ ڴ  DBManger ص ٸ Servant ϴ DBController Ҽ ִ. 
	 * Servant  ǰ ڿ   ϴ Ŭ̴. 
	 * 
	 *  StdOutServant      ð StdOut ´.
	 */
	
	public void testServant() throws Exception {
		DBController newDc = new DBController("newDC", dc.getDBManager()) ;
		newDc.addServant(new StdOutServant(StdOutServant.All)) ; //  IQueryable ȭ鿡 Ʈϴ Servant ߰Ѵ. 
		newDc.initSelf() ;
		
		newDc.getRows("select 1 from copy_sample") ;
		newDc.destroySelf() ;
	}
	

	/*
	 * Servant Chain Ǳ  ο Servant ؼ addָ 
	 * ϳ  ɶ Chain Servant óȴ. 
	 * 
	 * ⺻ DBController Sevant  Thread óϱ  Servant    ּȭȴ.
	 * 
	 *  Servant Ȱ پϴ. 
	 *  Ư  ɶ ͸ ϰų   ϴ Servant Ҽ ְ..
	 *   ̻  ð ϴ    ϴ ExtraServant  ִ. 
	 *  
	 */

	public void testServantChain() throws Exception {
		DBController newDc = new DBController("newDC", dc.getDBManager()) ;
		newDc.addServant(new StdOutServant(StdOutServant.All)) ; //  IQueryable ȭ鿡 Ʈϴ Servant ߰Ѵ. 
		newDc.addServant(new StdOutServant(StdOutServant.All)) ; // Ѱ  ߰Ѵ. 
		newDc.initSelf() ;
		
		newDc.getRows("select 1 from copy_sample") ;
		newDc.destroySelf() ;
	}

	
}
