package com.bleujin.framework.db.servant;

import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.bleujin.framework.logging.LogBroker;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * shutDownRequest  ٷ ؾ ϳ? ƴϸ  ִ Task óϰ ؾ ϴ°? -_-a
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class ServantChannel {

    private static final int MAX_MESSAGE = 2000;
    private final LinkedList taskQueue ;

    private ExtraServant topServant;
    protected final Logger log;

    private volatile boolean shutDownRequest = false;


    public ServantChannel( ExtraServant servant) {
        this.taskQueue = new LinkedList() ;

        topServant = servant ;
        log = LogBroker.getLogger(this);

        // log.info("init Channel : " + servant.toString());
    }

    public void startWorker() {
        topServant.start() ;
    }

    public synchronized void putTask(AfterTask atask) throws InterruptedException {
        while (getCount() >= MAX_MESSAGE) {
            wait();
        }
        taskQueue.addLast(atask);

        if (getCount() > (MAX_MESSAGE /2) ){
            log.log(Level.WARNING, "Warning.. reach at the half of queue size.. if any exeption not exists, consider to increase queue's max size");
            log.log(Level.WARNING, "task : " + atask) ;
        }

        notifyAll();
    }

    public synchronized AfterTask takeTask() throws InterruptedException {
        while ( getCount() <= 0) {
            wait();
        }

        AfterTask task = (AfterTask)taskQueue.removeFirst();

        notifyAll();
        return task;
    }

    private int getCount() {
        return taskQueue.size();
    }

    public synchronized void stopServant() {
        topServant.stopServant();
    }

    public ExtraServant getExtraServant(){
        return topServant ;
    }

	public void restartWorker() {
    	taskQueue.clear() ;
		ExtraServant clone = topServant.newCloneInstance() ;
		clone.setChannel(this) ;
		if (topServant.getNextServant() != null){
			clone.setNext(topServant.getNextServant()) ;
		}
		topServant = clone ;
		startWorker() ;
	}
}

