package com.bleujin.framework.parse.html;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;

import org.apache.commons.io.IOUtils;



public class HtmlParser {

	private static HtmlParser self = new HtmlParser() ;
	
	private HtmlParser(){
	}
	
	public final static HTag parse(Reader content) throws IOException {
		return self.parseContent(content, 0) ;
	}

	public final static HTag parse(Reader content, int index) throws IOException {
		return self.parseContent(content, index) ;
	}

	private HTag parseContent(Reader reader, int index) throws IOException {
		// copy new content ;
		Reader content = new InputStreamReader(new ByteArrayInputStream(IOUtils.toByteArray(reader))) ;
		
		return HTag.create(content, index) ;
	}

}
