package com.bleujin.framework.util;

import java.io.ByteArrayOutputStream;

public class ByteUtil {

	public static String bytesToHex(byte bytes[], int offset, int length, boolean wrap) {
		StringBuffer sb = new StringBuffer();
		for (int i = offset; i < offset + length; ++i) {
			if (i > offset) {
				sb.append(" ");
			}
			sb.append(Integer.toHexString(0x0100 + (bytes[i] & 0x00FF)).substring(1));
			if (i > 0 && (i + 1) % 16 == 0 && wrap) {
				sb.append("\n");
			}
		}
		return sb.toString();
	}
	
	private static final byte[] EMPTY_BYTES = new byte[0];
	public static byte[] hexToBytes(String hex) {
		if (hex == null) {
			return EMPTY_BYTES;
		}
		hex = hex.replaceAll("\\s+", "");
		if (hex.length() == 0) {
			return EMPTY_BYTES;
		}
		ByteArrayOutputStream baos = new ByteArrayOutputStream(hex.length() / 2);
		byte b;
		for (int i = 0; i < hex.length(); i++) {
			int high = charToNibble(hex.charAt(i));
			int low = 0;
			if (i < hex.length() - 1) {
				i++;
				low = charToNibble(hex.charAt(i));
			}
			b = (byte) (high << 4 | low);
			baos.write(b);
		}
		return baos.toByteArray();
	}

	static final int charToNibble(char c) {
		if (c >= '0' && c <= '9') {
			return c - '0';
		} else if (c >= 'a' && c <= 'f') {
			return 0xa + (c - 'a');
		} else if (c >= 'A' && c <= 'F') {
			return 0xA + (c - 'A');
		} else {
			throw new RuntimeException("Not a hex character: '" + c + "'");
		}
	}

	public static String byteToHex(byte b) {
		return bytesToHex(new byte[] { b }, 0, 1, false);
	}
}
