package com.bleujin.framework.util;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Arrays;

public class Debug extends OutputStream {

	public final static String PROPERTY_KEY = "framework.debug.out" ;
	private static void out(String message) {
		out(0, message) ;
	}
	private static void out(final int level, String message) {

		if ("off".equals(System.getProperty(PROPERTY_KEY))) return ;
		
		StackTraceElement[] stackTraces = new Exception().getStackTrace();
		String thisName = Debug.class.getName();
		for (StackTraceElement st : stackTraces) {
			String className = st.getClassName();
			if (!thisName.equals(className)) {

				String callerClass = st.getClassName();
				String callerMethod = st.getMethodName();
				System.out.println(StringUtil.leftPad(" ", level*4)+ message + " by " + callerClass + ":" + callerMethod);
				break;
			}
		}
	}

	public static void error(Object... objs) {
		debug(objs);
	}

	public static void debug(Object... objs) {
		out(Arrays.deepToString(objs));
	}

	public static void message(int level, Object... objs) {
		out(level, Arrays.deepToString(objs));
	}

	public static void line() {
		line("");
	}

	public static void line(Object... objs) {
		debug("=================================", objs);
	}

	public void write(int b) throws IOException {
		System.out.print(b);
	}

	public static void happy(Object... objs) {
		// TODO Auto-generated method stub

	}

	public static void happy(Class cls, Object... objs) {
		// TODO Auto-generated method stub
	}

	public static void warning(Object... objs) {
		out(Arrays.deepToString(objs));
	}

}
