package com.bleujin.framework.util;


public class StringUtil extends org.apache.commons.lang.StringUtils {

    public final static String T = "T" ;
    public final static String TRUE = "TRUE" ;

    public static boolean isAlphaUnderbarStartWith(String str){
    	if (isBlank(str) || str.length() < 1) return false ;
        char ch = str.charAt(0) ;
        if( (ch >= 'A' && ch <= 'Z') || (ch >= 'a' && ch <= 'z') || ch == '_' ){
            return true ;
        } else return false ;
    	
    }
    
    public static boolean isAlphanumericUnderbar(String str){
    	
        if (str == null) {
            return false;
        }
        char[] chars = str.toCharArray() ;
        for (int i = 0, last = chars.length; i < last; i++) {
            char ch = chars[i] ;
            if( (ch >= 'A' && ch <= 'Z') || (ch >= 'a' && ch <= 'z') || (ch >= '0' && ch <= '9') || ch == '_' ){
                continue ;
            } else return false ;
        }
        return true;
    }

    public static boolean isAlphanumericUnderbarDash(String str){

        if (str == null) {
            return false;
        }
        char[] chars = str.toCharArray() ;
        for (int i = 0, last = chars.length; i < last; i++) {
            char ch = chars[i] ;
            if( (ch >= 'A' && ch <= 'Z') || (ch >= 'a' && ch <= 'z') || (ch >= '0' && ch <= '9') || ch == '_'  || ch == '-' ){
                continue ;
            } else return false ;
        }
        return true;
    }

    // length >= 4 and smallAlpahNumUnderBar 
    public static boolean isIdAble(String str, int minLength, int maxLength){
    	if (! isSmallAlphaNumUnderBar(str)) return false ;
    	if (str.length() < minLength || str.length() > maxLength) return false ;
    	
    	return true ;
    }
    
    
    public static boolean isSmallAlphaNumUnderBar(String str){

        if (str == null) {
            return false;
        }
        char[] chars = str.toCharArray() ;
        for (int i = 0, last = chars.length; i < last; i++) {
            char ch = chars[i] ;
            if( (ch >= 'a' && ch <= 'z') || (ch >= '0' && ch <= '9') || ch == '_' ){
                continue ;
            } else return false ;
        }
        return true;
    }

    
    public static boolean isSmallAlphaNumUnderBarSlash(String str){

        if (str == null) {
            return false;
        }
        char[] chars = str.toCharArray() ;
        for (int i = 0, last = chars.length; i < last; i++) {
            char ch = chars[i] ;
            if( (ch >= 'a' && ch <= 'z') || (ch >= '0' && ch <= '9') || ch == '_' || ch == '/'){
                continue ;
            } else return false ;
        }
        return true;
    }
    public static boolean isIncludeIgnoreCase(String[] array, String arg){

        if ( (array == null) || array.length == 0 || arg == null){
            return false ;
        }

        for(int i = 0, length = array.length ; i < length ; ++i) {
            if(arg.equalsIgnoreCase(array[i])) {
                return true ;
            }
        }
        return false ;
    }

    public static String join(int[] ints){
        return join(ints, ',') ;
    }

    public static String join(int[] ints, char c){
        String[] s = new String[ints.length] ;
        for (int i = 0; i < s.length; i++) {
            s[i] = String.valueOf(ints[i]) ;
        }

        return join(s, c) ;
    }

    public static String escapeControlChar(String str) {
        char[] charArray =  str.toCharArray();
        char[] target  = new char[charArray.length] ;

        int k = 0 ;
        for (int i = 0; i < charArray.length; i++) {
//            if (charArray[i] >= 32 || charArray[i] == '\n' || charArray[i] == '\r' || charArray[i] == '\t') {
            if (Character.isIdentifierIgnorable(charArray[i])) continue ;
            if (charArray[i] >= 32 || charArray[i] == '\n' || charArray[i] == '\r' || charArray[i] == '\t') {
                target[k++] = charArray[i] ;
            } else {
            }
        }

        char[] result = new char[k] ;
        System.arraycopy(target, 0, result, 0, k) ;

        return new String(result);
    }


	public static String filterHTML(String value) {
		if (value == null) {
			return (null);
		}

		char content[] = new char[value.length()];
		value.getChars(0, value.length(), content, 0);
		StringBuffer result = new StringBuffer(content.length + 50);
		for (int i = 0; i < content.length; i++) {
			switch (content[i]) {
			case '<':
				result.append("&lt;");
				break;
			case '>':
				result.append("&gt;");
				break;
			case '&':
				result.append("&amp;");
				break;
			case '"':
				result.append("&quot;");
				break;
			case '\'':
				result.append("&#39;");
				break;
			case ' ':
				result.append("&nbsp;");
				break;
			default:
				result.append(content[i]);
			}
		}
		return (result.toString());
	}

	
	
}
