package com.bleujin.framework.util.reflect;

import junit.framework.TestCase;

import org.apache.commons.beanutils.ConstructorUtils;
import org.apache.commons.beanutils.MethodUtils;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.lang.ClassUtils;

public class ReflectionTest extends TestCase{

	public void testInvokeMethod() throws Exception {
		
		Bean b = new Bean() ;
		b.setValue(5) ;
		b.setLocation("abc") ;
		
		
		
		Object o = MethodUtils.invokeMethod(b, "getValue", null) ;
		assertEquals(5, o) ;
		
		
		Object o2 = PropertyUtils.getProperty(b, "value") ;
		assertEquals(5, o) ;
		
	}
	
	
	public void testReflectMethod() throws Exception {
		Class c = ClassUtils.getClass("com.bleujin.framework.util.reflect.Bean") ;
		Object o = ConstructorUtils.invokeConstructor(c, null) ;
		((Bean)o).setValue(5) ;
		assertEquals(5, ((Bean)o).getValue()) ;
	}

}

