package com.bleujin.framework.util.reflect.before;

import org.apache.commons.lang.exception.NestableRuntimeException;

/**
 * Exception thrown when the Reflection process fails. The original error is
 * wrapped within this one.
 * 
 * @author <a href="mailto:scolebourne@joda.org">Stephen Colebourne</a>
 * @version $Id: ReflectionException.java,v 1.1 2002/10/24 23:12:54 scolebourne
 *          Exp $
 */

public class ReflectionException extends NestableRuntimeException {

	public ReflectionException() {
		super();
	}

	public ReflectionException(String msg) {
		super(msg);
	}

	public ReflectionException(Throwable cause) {
		super(cause);
	}

	public ReflectionException(String msg, Throwable cause) {
		super(msg, cause);
	}

}
