package com.bleujin.framework.valid.validator;

import java.io.UnsupportedEncodingException;
import java.lang.reflect.InvocationTargetException;

import org.apache.commons.beanutils.PropertyUtils;

import com.bleujin.framework.valid.IValueObject;
import com.bleujin.framework.valid.ValidatorException;

public abstract class BaseValidation implements IValidation{

	private IValueObject value ;
	private String name ;
	public BaseValidation(IValueObject value, String name){
		this.value = value ;
		this.name = name ;
	}
	
	protected String getName(){
		return name ;
	}
	
	protected Object invokeGetter(String name) throws ValidatorException{
		try {
			return PropertyUtils.getProperty(value, name) ;
		} catch (IllegalAccessException e) {
			throw new ValidatorException(e) ;
		} catch (InvocationTargetException e) {
			throw new ValidatorException(e) ;
		} catch (NoSuchMethodException e) {
			throw new ValidatorException(e) ;
		}
	}

	protected Object invokeGetter(){
		return invokeGetter(getName()) ;
	}
	
	protected int getPropertyLength(){
		Object value = invokeGetter() ;
		if (value == null) return 0 ;
		
		return value.toString().length() ;
	}

	protected int getPropertyUTF8ByteLength() {
		Object value = invokeGetter() ;
		if (value == null) return 0 ;
		try {
			return value.toString().getBytes("UTF8").length ;
		} catch (UnsupportedEncodingException e) {
			throw new IllegalArgumentException(e);
		}
	}

}
