package com.bleujin.framework.valid.validator;

import java.util.Date;

import com.bleujin.framework.util.DateUtil;
import com.bleujin.framework.valid.IValueObject;

public class DateFormatString extends BaseValidation{


	private String format ;
	
	public DateFormatString(IValueObject valueObject, String name){
		this(valueObject, name, "yyyyMMdd-HHmmss") ;
	}
	
	public DateFormatString(IValueObject valueObject, String name, String format){
		super(valueObject, name) ;
		this.format = format ;
	}

	public boolean isValid() {
		Object value = invokeGetter() ;
		if (value == null) return false ;
		
		try {
			
			Date d = DateUtil.stringToDate(value.toString(), format) ;
			return true ;
		} catch (IllegalArgumentException e) {
			return false ;
		}
		
	}

}
